---
title: Introduction to the Real-time Transport Protocol (RTP)
slug: Web/API/WebRTC_API/Intro_to_RTP
tags:
  - API
  - Connectivity
  - Guide
  - Intermediate
  - Protocols
  - RTCRtpReceiver
  - RTCRtpSender
  - RTCRtpTransceiver
  - RTP
  - WebRTC
---
<div>{{APIRef("WebRTC")}}{{draft}}</div>

<p><span class="seoSummary">The <strong>Real-time Transport Protocol</strong> (<strong>RTP</strong>), defined in {{RFC(3550)}}, is an IETF standard protocol to enable real-time connectivity for exchanging data that needs real-time priority. This article provides an overview of what RTP is and how it functions in the context of WebRTC.</span></p>

<div class="note">
<p><strong>Note:</strong> WebRTC actually uses <strong>SRTP</strong> (Secure Real-time Transport Protocol) to ensure that the exchanged data is secure and authenticated as appropriate.</p>
</div>

<p>Keeping latency to a minimum is especially important for WebRTC, since face-to-face communication needs to be performed with as little {{Glossary("latency")}} as possible. The more time lag there is between one user saying something and another hearing it, the more likely there is to be episodes of cross-talking and other forms of confusion.</p>

<h2 id="Key_features_of_RTP">Key features of RTP</h2>

<p>Before examining RTP's use in WebRTC contexts, it's useful to have a general idea of what RTP does and does not offer. RTP is a data transport protocol, whose mission is to move data between two endpoints as efficiently as possible under current conditions. Those conditions may be affected by everything from the underlying layers of the network stack to the physical network connection, the intervening networks, the performance of the remote endpoint, noise levels, traffic levels, and so forth.</p>

<p>Since RTP is a data transport, it is augmented by the closely-related <strong>RTP Control Protocol</strong> (<strong>RTCP</strong>), which is defined in {{RFC(3550, "", 6)}}. RTCP adds features including <strong>Quality of Service</strong> (<strong>QoS</strong>) monitoring, participant information sharing, and the like. It isn't adequate for the purposes of fully managing users, memberships, permissions, and so forth, but provides the basics needed for an unrestricted multi-user communication session.</p>

<p>The very fact that RTCP is defined in the same RFC as RTP is a clue as to just how closely-interrelated these two protocols are.</p>

<h3 id="Capabilities_of_RTP">Capabilities of RTP</h3>

<p>RTP's primary benefits in terms of WebRTC include:</p>

<ul>
 <li>Generally low latency.</li>
 <li>Packets are sequence-numbered and time-stamped for reassembly if they arrive out of order. This lets data sent using RTP be delivered on transports that don't guarantee ordering or even guarantee delivery at all.</li>
 <li>This means RTP can be — but is not required to be — used atop {{Glossary("UDP")}} for its performance as well as its multiplexing and checksum features.</li>
 <li>RTP supports multicast; while this isn't yet important for WebRTC, it's likely to matter in the future, when WebRTC is (hopefully) enhanced to support multi-user conversations.</li>
 <li>RTP isn't limited to use in audiovisual communication. It can be used for any form of continuous or active data transfer, including data streaming, active badges or status display updates, or control and measurement information transport.</li>
</ul>

<h3 id="Things_RTP_doesn't_do">Things RTP doesn't do</h3>

<p>RTP itself doesn't provide every possible feature, which is why other protocols are also used by WebRTC. Some of the more noteworthy things RTP doesn't include:</p>

<div class="callout-box">Editor's note: we should add information about where these deficiencies are compensated for, if they are at all.</div>

<ul>
 <li>RTP does <em>not</em> guarantee <strong>{{interwiki("wikipedia", "quality-of-service")}}</strong> (<strong>QoS</strong>).</li>
 <li>While RTP is intended for use in latency-critical scenarios, it doesn't inherently offer any features that ensure QoS. Instead, it only offers the information necessary to allow QoS to be implemented elsewhere in the stack.</li>
 <li>RTP doesn't handle allocation or reservation of resources that may be needed.</li>
</ul>

<p>Where it matters for WebRTC purposes, these are dealt with in a variety of places within the WebRTC infrastructure. For example, RTCP handles QoS monitoring.</p>

<h2 id="RTCPeerConnection_and_RTP">RTCPeerConnection and RTP</h2>

<p>Each {{domxref("RTCPeerConnection")}} has methods which provide access to the list of RTP transports that service the peer connection. These correspond to the following three types of transport supported by <code>RTCPeerConnection</code>:</p>

<dl>
 <dt>{{domxref("RTCRtpSender")}}</dt>
 <dd><code>RTCRtpSender</code>s handle the encoding and transmission of {{domxref("MediaStreamTrack")}} data to a remote peer. The senders for a given connection can be obtained by calling {{domxref("RTCPeerConnection.getSenders()")}}.</dd>
 <dt>{{domxref("RTCRtpReceiver")}}</dt>
 <dd><code>RTCRtpReceiver</code>s provide the ability to inspect and obtain information about incoming <code>MediaStreamTrack</code> data. A connection's receivers can be obtained by calling {{domxref("RTCPeerConnection.getReceivers()")}}.</dd>
 <dt>{{domxref("RTCRtpTransceiver")}}</dt>
 <dd>An <code>RTCRtpTransceiver</code> is a pair of one RTP sender and one RTP receiver which share an SDP <code>mid</code> attribute, which means they share the same SDP media m-line (representing a bidirectional SRTP stream). These are returned by the {{domxref("RTCPeerConnection.getTransceivers()")}} method, and each <code>mid</code> and transceiver share a one-to-one relationship, with the <code>mid</code> being unique for each <code>RTCPeerConnection</code>.</dd>
</dl>

<h3 id="Leveraging_RTP_to_implement_a_hold_feature">Leveraging RTP to implement a "hold" feature</h3>

<p>Because the streams for an <code>RTCPeerConnection</code> are implemented using RTP and the interfaces {{anch("RTCPeerConnection and RTP", "above")}}, you can take advantage of the access this gives you to the internals of streams to make adjustments. Among the simplest things you can do is to implement a "hold" feature, wherein a participant in a call can click a button and turn off their microphone, begin sending music to the other peer instead, and stop accepting incoming audio.</p>

<div class="note">
<p><strong>Note:</strong> This example makes use of modern JavaScript features including <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async functions</a> and the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/await">await</a></code> expression. This enormously simplifies and makes far more readable the code dealing with the promises returned by WebRTC methods.</p>
</div>

<p>In the examples below, we'll refer to the peer which is turning "hold" mode on and off as the local peer and the user being placed on hold as the remote peer.</p>

<h4 id="Activating_hold_mode">Activating hold mode</h4>

<ol>
</ol>

<h5 id="Local_peer">Local peer</h5>

<p>When the local user decides to enable hold mode, the <code>enableHold()</code> method below is called. It accepts as input a {{domxref("MediaStream")}} containing the audio to play while the call is on hold.</p>

<pre class="brush: js">async function enableHold(audioStream) {
  try {
    await audioTransceiver.sender.replaceTrack(audioStream.getAudioTracks()[0]);
    audioTransceiver.receiver.track.enabled = false;
    audioTransceiver.direction = "sendonly";
  } catch(err) {
    /* handle the error */
  }
}</pre>

<p>The three lines of code within the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/try...catch">try</a></code> block perform the following steps:</p>

<ol>
 <li>Replace their outgoing audio track with a {{domxref("MediaStreamTrack")}} containing hold music.</li>
 <li>Disable the incoming audio track.</li>
 <li>Switch the audio transceiver into send-only mode.</li>
</ol>

<p>This triggers renegotiation of the <code>RTCPeerConnection</code> by sending it a {{event("negotiationneeded")}} event, which your code responds to generating an SDP offer using {{domxref("RTCPeerConnection.createOffer")}} and sending it through the signaling server to the remote peer.</p>

<p>The <code>audioStream</code>, containing the audio to play instead of the local peer's microphone audio, can come from anywhere. One possibility is to have a hidden {{HTMLElement("audio")}} element and use {{domxref("HTMLMediaElement.captureStream", "HTMLAudioElement.captureStream()")}} to get its audio stream.</p>

<h5 id="Remote_peer">Remote peer</h5>

<p>On the remote peer, when we receive an SDP offer with the directionality set to <code>"sendonly"</code>, we handle it using the <code>holdRequested()</code> method, which accepts as input an SDP offer string.</p>

<pre class="brush: js">async function holdRequested(offer) {
  try {
    await peerConnection.setRemoteDescription(offer);
    await audioTransceiver.sender.replaceTrack(null);
    audioTransceiver.direction = "recvonly";
    await sendAnswer();
  } catch(err) {
    /* handle the error */
  }
}
</pre>

<p>The steps taken here are:</p>

<ol>
 <li>Set the remote description to the specified <code>offer</code> by calling {{domxref("RTCPeerConnection.setRemoteDescription()")}}.</li>
 <li>Replace the audio transceiver's {{domxref("RTCRtpSender")}}'s track with <code>null</code>, meaning no track. This stops sending audio on the transceiver.</li>
 <li>Set the audio transceiver's {{domxref("RTCRtpTransceiver.direction", "direction")}} property to <code>"recvonly"</code>, instructing the transceiver to only accept audio and not to send any.</li>
 <li>The SDP answer is generated and sent using a method called <code>sendAnswer()</code>, which generates the answer using {{domxref("RTCPeerConnection.createAnswer", "createAnswer()")}} then sends the resulting SDP to the other peer over the signaling service.</li>
</ol>

<h4 id="Deactivating_hold_mode">Deactivating hold mode</h4>

<h5 id="Local_peer_2">Local peer</h5>

<p>When the local user clicks the interface widget to disable hold mode, the <code>disableHold()</code> method is called to begin the process of restoring normal functionality.</p>

<pre class="brush: js">async function disableHold(micStream) {
  await audioTransceiver.sender.replaceTrack(micStream.getAudioTracks()[0]);
  audioTransceiver.receiver.track.enabled = true;
  audioTransceiver.direction = "sendrecv";
}</pre>

<p>This reverses the steps taken in <code>enableHold()</code> as follows:</p>

<ol>
 <li>The audio transceiver's <code>RTCRtpSender</code>'s track is replaced with the specified stream's first audio track.</li>
 <li>The transceiver's incoming audio track is re-enabled.</li>
 <li>The audio transceiver's direction is set to <code>"sendrecv"</code>, indicating that it should return to both sending and receiving streamed audio, instead of only sending.</li>
</ol>

<p>Just like when hold was engaged, this triggers negotiation again, resulting in your code sending a new offer to the remote peer.</p>

<h5 id="Remote_peer_2">Remote peer</h5>

<p>When the <code>"sendrecv"</code> offer is received by  the remote peer, it calls its <code>holdEnded()</code> method:</p>

<pre class="brush: js">async function holdEnded(offer, micStream) {
  try {
    await peerConnection.setRemoteDescription(offer);
    await audioTransceiver.sender.replaceTrack(micStream.getAudioTracks()[0]);
    audioTransceiver.direction = "sendrecv";
    await sendAnswer();
  } catch(err) {
    /* handle the error */
  }
}
</pre>

<p>The steps taken inside the <code>try</code> block here are:</p>

<ol>
 <li>The received offer is stored as the remote description by calling <code>setRemoteDescription()</code>.</li>
 <li>The audio transceiver's <code>RTCRtpSender</code>'s {{domxref("RTCRtpSender.replaceTrack", "replaceTrack()")}} method is used to set the outgoing audio track to the first track of the microphone's audio stream.</li>
 <li>The transceiver's direction is set to <code>"sendrecv"</code>, indicating that it should resume both sending and receiving audio.</li>
</ol>

<p>From this point on, the microphone is re-engaged and the remote user is once again able to hear the local user, as well as speak to  them.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
</ul>
